import copy
import emccanon
import recorder
import linuxcnc
from math import atan,sin,cos,tan,degrees,pi,sqrt,floor,ceil
import remap


from interpreter import *
# raises InterpreterException if execute() or read() fails
throw_exceptions = 1


#from stdglue import  init_stdglue

def g01(self,**words):
    words["code"] = "g0"
    recorder.add(words)
    recorder.add2(words) 

def g11(self,**words): 
    words["code"] = "g1"
    recorder.add(words)
    recorder.add2(words)

def g21(self,**words):
    words["code"] = "g2"
    recorder.add(words)
    recorder.add2(words)

def g31(self,**words):
    words["code"] = "g3"
    recorder.add(words)
    recorder.add2(words)




def g70(self,**words):
    q = int(words["q"])
    profile1 = int(words["q"])
    start_x = self.current_x
    start_z = self.current_z
    ini_x = self.current_x


 
      
    #### extraemos todas las 'X' del perfil ##### 
    stx = [] 
    for cv in recorder.perfilacabado[q]:
        if 'x' in cv:   
            stx.append(cv['x'])
    print stx 

    #### generacion del bucle para el ciclo G70 ######
    self.execute("G0 X%f" % (2*stx[0]))  
    self.execute("G0 Z%f" % (start_z))
    hx = 0
    hz = 0 
    for h in recorder.perfilacabado[q]:         
        if h['code'] == 'g1':
            if 'x' in h:
                if 'z' in h:
                    self.execute("G1 X%f Z%f" % ((2*h['x']), h['z']))   
            if not 'x' in h:
                if 'z' in h:
                    self.execute("G1 Z%f" % h['z'])
            if not 'z' in h:
                if 'x' in h:
                    self.execute("G1 X%f" % (2*h['x']))
        if h['code'] == 'g2':
            self.execute("G2 X%f Z%f R%f" % ((2*h['x']), h['z'], h['r']))
        if h['code'] == 'g3':
            self.execute("G3 X%f Z%f R%f" % ((2*h['x']), h['z'], h['r']))          

    self.execute("G0 Z%f" % (start_z))  

     
    ##### alarma #####
    if not  recorder.perfilacabado.has_key(q):
        return "G70: profile %d not defined" % q
   
    ### borramos todo lo que hay en estos contenedores ####### 

    stx = list()
    recorder.perfilacabado[q] = list() 
    return INTERP_OK






def g713(self,**words):
    c = self.blocks[self.remap_level]
    p = c.p_number if c.p_flag else 0
    i = c.i_number if c.i_flag else 0
    k = c.k_number if c.k_flag else 0
    r = c.r_number if c.r_flag else 0 
    q = int(words["q"])
    profile = int(words["q"])
    start_x = self.current_x
    start_z = self.current_z
    ini_x = self.current_x
    ini_xx = self.current_x
    perfil4 = list()    

    perfil = recorder.profiles[q]  
      
    stx = [] 
    for cv in perfil:
        if 'x' in cv:   
            stx.append(cv['x'])
 
   
    pasadas = ceil(abs(((stx[-1]-stx[0]) / p)))

    end_z = 0
    ex = 0 
    ez = 0
    sz = 0
    sx = 0 
    for x in range(1, pasadas):
        if start_x > stx[0]: 
            start_x = start_x - p            
        if start_x < stx[0]:
            start_x = start_x + p
        z = []    
        for b, c in zip(perfil, perfil[1:]):
            if 'x' in b:
                if start_x > stx[0]:             
                    ex = b['x'] + (i/2)
                else:
                    ex = b['x'] - (i/2) 
            if 'x' in c:
                if start_x > stx[0]:             
                    sx = c['x'] + (i/2)
                else:
                    sx = c['x'] - (i/2)
            if 'z' in b: 
                ez = b['z'] + k
            if 'z' in c:
                sz = c['z'] + k  
            if start_x > stx[0]:
                if start_x >= ex and start_x < sx:  
                    if ex < sx and ez >= sz:
                        if len(c) > 2:
                            if c['code'] == 'g2':
                                cat1 = abs(sx-(start_x))
                                cat2 = abs((c['r'])**2 - (cat1)**2)
                                cateto = abs(sqrt(cat2))
                                end_z = ez - cateto 
                                z.append(end_z)
                            elif c['code'] == 'g3':
                                cat1 = abs(ex-(start_x))
                                cat2 = abs((c['r'])**2 - (cat1)**2)
                                cateto = abs(sqrt(cat2))
                                end_z = sz + cateto
                                z.append(end_z)
                            elif c['code'] == 'g1':
                                x1 = abs(((ex-sx)/2))
                                z1 = abs(ez - sz)                 
                                ang = z1 / x1
                                cady = abs(((start_x - sx)/2)) 
                                cz = ang * cady
                                end_z = sz + cz
                                z.append(end_z)
                    
            if start_x < stx[0]:
                if start_x < ex and start_x >= sx:                            
                   if ex > sx and ez >= sz:
                        if len(c) > 2:
                            if c['code'] == 'g2':
                                cat1 = abs(ex-(start_x))
                                cat2 = abs((c['r'])**2 - (cat1)**2)
                                cateto = abs(sqrt(cat2))
                                end_z = sz + cateto
                                z.append(end_z)    
                            elif c['code'] == 'g3':
                                cat1 = abs(sx-(start_x))
                                cat2 = abs((c['r'])**2 - (cat1)**2)
                                cateto = abs(sqrt(cat2))
                                end_z = ez - cateto
                                z.append(end_z)
                            elif c['code'] ==  "g1":  
                                x1 = abs(((ex-sx)/2))
                                z1 = abs(ez - sz)                
                                ang = float(abs(z1 / x1))
                                cady = abs(((start_x - sx)/2)) 
                                cz = ang * cady
                                end_z = sz + cz 
                                z.append(end_z)                          
        self.execute("G0 X%f" % (2*start_x))
        self.execute("G1 Z%f" % max(z))
        if start_x > stx[0]:
            self.execute("G1 X%f" % (2*start_x+r))
        if start_x < stx[0]:
            self.execute("G1 X%f" % (2*start_x-r))  
        self.execute("G0 Z%f" % (start_z)) 
       

                           


   
    hx = 0
    hz = 0 
    for h in perfil:           
        if 'x' in h:
            if start_x > stx[0]:
                hx = h['x'] + (i/2)
            else:
                hx = h['x'] - (i/2)
        if 'z' in h:
            hz = h['z'] + k
        if h['code'] == 'g0':
            self.execute("G0 X%f" % (2*hx))
        if h['code'] == 'g1':
            if 'x' in h:
                if 'z' in h:
                    self.execute("G1 X%f Z%f" % ((2*hx), hz))   
            if not 'x' in h:
                if 'z' in h:
                    self.execute("G1 Z%f" % hz)
            if not 'z' in h:
                if 'x' in h:
                    self.execute("G1 X%f" % (2*hx))
        if h['code'] == 'g2':
            self.execute("G2 X%f Z%f R%f" % ((2*hx), hz, h['r']))
        if h['code'] == 'g3':
            self.execute("G3 X%f Z%f R%f" % ((2*hx), hz, h['r']))      


        
                     
    self.execute("G0 Z%f" % (start_z))     

    if not  recorder.profiles.has_key(q):
        return "G70: profile %d not defined" % q

    perfil4 = list() 
    perfil = list()      
    stx = list()
    recorder.profiles[profile] = list()      
    return INTERP_OK


